package se.plweb.memory.domain;

/**
 * @author Peter Lindblom
 * 
 */

public abstract class AbstractThread implements Runnable {
	protected Thread thread = new Thread(this);
	protected volatile boolean running = false;
	protected volatile boolean firstTime = true;

	protected boolean isRunning() {
		return running;
	}

	protected void setRunning(boolean running) {
		this.running = running;
	}

	protected boolean isFirstTime() {
		return firstTime;
	}

	protected void setFirstTime(boolean firstTime) {
		this.firstTime = firstTime;
	}

	public void stop() {
		if (isRunning()) {
			setRunning(false);
		}
	}
}
