package se.plweb.memory.gui;

import java.awt.*;
import java.util.ArrayList;

public class ColorHelper {
    private static int red = 0;
    private static int green = 0;
    private static int blue = 0;
    private static enum IncrementColor {RED, GREEN, BLUE}
    private static IncrementColor currentIncrementColor = IncrementColor.RED;
    private static java.util.List<Color> colorForValues = new ArrayList<Color>(); 

    static {
        for(int i=0;i<500;i++){
            colorForValues.add(getNextColor(30));
        }        
    }

    public static Color getColorForValue(int value){
        return colorForValues.get( (value -1) );
    }

    protected static void reset(){
        currentIncrementColor = IncrementColor.RED;
        red = 0;
        green = 0;
        blue = 0;
    }

    protected static Color getNextColor(int increment){
        generateRGBValues(increment);
        return new Color(red, green, blue);
    }

    private static void generateRGBValues(int increment){
        if(currentIncrementColor.equals(IncrementColor.RED)){
            red = increment(red, increment);
            if(red == 0){
                currentIncrementColor = IncrementColor.GREEN;
            }
        }else if(currentIncrementColor.equals(IncrementColor.GREEN)){
            green = increment(green, increment);
            if(green == 0){
                currentIncrementColor = IncrementColor.BLUE;
            }
        }else if(currentIncrementColor.equals(IncrementColor.BLUE)){
            blue = increment(blue, increment);
            if(blue == 0){
                currentIncrementColor = IncrementColor.RED;
            }
        }

    }

    protected static boolean isLargerThenMaxByteValue(int value){
        if(value >= 256){
            return true;
        }
        return false;
    }

    protected static int increment(int value, int increment){
        int result = (value + increment);
        if(isLargerThenMaxByteValue(result)){
            result = 0;
        }
        return result;        
    }

}
