package se.plweb.memory.gui;

import junit.framework.TestCase;

import java.awt.*;

import static se.plweb.memory.gui.ColorHelper.getNextColor;
import static se.plweb.memory.gui.ColorHelper.reset;

public class ColorHelperTest extends TestCase {

    private static final int increment = 100; 

    private boolean debug = false;

    public ColorHelperTest(String name){
        super(name);
    }

    private void print(String input){
        if(debug){
            System.out.println(input);
        }
    }

    public void testGetNextColor(){

        reset();        
        Color actual = getNextColor(increment);
        Color expected = new Color(increment,0,0);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);

        actual = getNextColor(increment);
        expected = new Color((increment * 2),0,0);
        
        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);

        actual = getNextColor(increment);
        expected = new Color(0,0,0);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);

        actual = getNextColor(increment);
        expected = new Color(0,increment,0);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);
        
        actual = getNextColor(increment);
        expected = new Color(0,(increment*2),0);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);
        
        actual = getNextColor(increment);
        expected = new Color(0,0,0);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);
        
        actual = getNextColor(increment);
        expected = new Color(0,0,increment);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);

        actual = getNextColor(increment);
        expected = new Color(0,0,(increment*2));

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);

        actual = getNextColor(increment);
        expected = new Color(0,0,0);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);

        actual = getNextColor(increment);
        expected = new Color(increment,0,0);

        assertEquals(expected.getRed(), actual.getRed());
        assertEquals(expected.getGreen(), actual.getGreen());
        assertEquals(expected.getBlue(), actual.getBlue());
        print(expected +"="+ actual);
    }

}
